#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const yargs = require("yargs");
const request_1 = require("../request");
const lint_1 = require("./commands/lint");
if (process.env.PROXY) {
    const ProxyAgent = require('proxy-agent');
    request_1.DEFAULT_REQUEST_OPTIONS.agent = new ProxyAgent(process.env.PROXY);
}
exports.default = yargs
    .scriptName('spectral')
    .parserConfiguration({
    'camel-case-expansion': true,
})
    .version()
    .help(true)
    .strict()
    .wrap(yargs.terminalWidth())
    .command(lint_1.default)
    .demandCommand(1, '').argv;
//# sourceMappingURL=index.js.map