"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getResolver = void 0;
const path_1 = require("@stoplight/path");
const http_and_file_1 = require("../../../../resolvers/http-and-file");
exports.getResolver = (resolver) => {
    var _a;
    if (resolver !== void 0) {
        try {
            return require(path_1.isAbsolute(resolver) ? resolver : path_1.join(process.cwd(), resolver));
        }
        catch ({ message }) {
            throw new Error((_a = formatMessage(message)) !== null && _a !== void 0 ? _a : message);
        }
    }
    return http_and_file_1.createHttpAndFileResolver();
};
function formatMessage(message) {
    var _a, _b;
    return (_b = (_a = message.split(/\r?\n/)) === null || _a === void 0 ? void 0 : _a[0]) === null || _b === void 0 ? void 0 : _b.replace(/\\/g, '/');
}
//# sourceMappingURL=getResolver.js.map