"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getRuleset = void 0;
const path_1 = require("@stoplight/path");
const rulesets_1 = require("../../../../rulesets");
const loader_1 = require("../../../../rulesets/loader");
const formats_1 = require("../../../../formats");
async function loadRulesets(cwd, rulesetFiles, opts) {
    if (rulesetFiles.length === 0) {
        return {
            functions: {},
            rules: {},
            exceptions: {},
        };
    }
    return rulesets_1.readRuleset(rulesetFiles.map(file => (path_1.isAbsolute(file) ? file : path_1.resolve(cwd, file))), opts);
}
async function getRuleset(rulesetFile, opts) {
    const rulesetFiles = rulesetFile !== null && rulesetFile !== void 0 ? rulesetFile : (await loader_1.getDefaultRulesetFile(process.cwd()));
    return await (rulesetFiles !== null
        ? loadRulesets(process.cwd(), Array.isArray(rulesetFiles) ? rulesetFiles : [rulesetFiles], opts)
        : rulesets_1.readRuleset(formats_1.KNOWN_RULESETS, opts));
}
exports.getRuleset = getRuleset;
//# sourceMappingURL=getRuleset.js.map