"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeOutput = exports.formatOutput = void 0;
const fs_1 = require("fs");
const util_1 = require("util");
const formatters_1 = require("../formatters");
const writeFileAsync = util_1.promisify(fs_1.writeFile);
const formatters = {
    json: formatters_1.json,
    stylish: formatters_1.stylish,
    junit: formatters_1.junit,
    html: formatters_1.html,
    text: formatters_1.text,
    teamcity: formatters_1.teamcity,
};
function formatOutput(results, format, formatOptions) {
    return formatters[format](results, formatOptions);
}
exports.formatOutput = formatOutput;
async function writeOutput(outputStr, outputFile) {
    if (outputFile) {
        return writeFileAsync(outputFile, outputStr);
    }
    console.log(outputStr);
}
exports.writeOutput = writeOutput;
//# sourceMappingURL=output.js.map