"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isAsyncApiv2 = void 0;
const lodash_1 = require("lodash");
const bearsAStringPropertyNamed = (document, propertyName) => {
    return lodash_1.isObject(document) && propertyName in document && typeof document[propertyName] === 'string';
};
const version2Regex = /^2\.(0|[1-9][0-9]*)\.(0|[1-9][0-9]*)$/;
exports.isAsyncApiv2 = (document) => {
    if (!bearsAStringPropertyNamed(document, 'asyncapi')) {
        return false;
    }
    const version = String(document.asyncapi);
    return version2Regex.test(version);
};
//# sourceMappingURL=asyncapi.js.map