"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.KNOWN_RULESETS = exports.KNOWN_FORMATS = void 0;
const asyncapi_1 = require("./asyncapi");
const json_schema_1 = require("./json-schema");
const openapi_1 = require("./openapi");
exports.KNOWN_FORMATS = [
    ['oas2', openapi_1.isOpenApiv2, 'OpenAPI 2.0 (Swagger)'],
    ['oas3', openapi_1.isOpenApiv3, 'OpenAPI 3.x'],
    ['asyncapi2', asyncapi_1.isAsyncApiv2, 'AsyncAPI 2.x'],
    ['json-schema', json_schema_1.isJSONSchema, 'JSON Schema'],
    ['json-schema-loose', json_schema_1.isJSONSchemaLoose, 'JSON Schema (loose)'],
    ['json-schema-draft4', json_schema_1.isJSONSchemaDraft4, 'JSON Schema Draft 4'],
    ['json-schema-draft6', json_schema_1.isJSONSchemaDraft6, 'JSON Schema Draft 6'],
    ['json-schema-draft7', json_schema_1.isJSONSchemaDraft7, 'JSON Schema Draft 7'],
    ['json-schema-2019-09', json_schema_1.isJSONSchemaDraft2019_09, 'JSON Schema Draft 2019-09'],
];
exports.KNOWN_RULESETS = ['spectral:oas', 'spectral:asyncapi'];
//# sourceMappingURL=consts.js.map