"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.unreferencedReusableObject = void 0;
const lodash_1 = require("lodash");
const utils_1 = require("../utils");
exports.unreferencedReusableObject = (data, opts, _paths, otherValues) => {
    var _a;
    if (!lodash_1.isObject(data))
        return;
    const graph = otherValues.documentInventory.graph;
    if (graph === null) {
        return [{ message: 'unreferencedReusableObject requires dependency graph' }];
    }
    const normalizedSource = (_a = otherValues.documentInventory.source) !== null && _a !== void 0 ? _a : '';
    const defined = Object.keys(data).map(name => `${normalizedSource}${opts.reusableObjectsLocation}/${name}`);
    const orphans = defined.filter(defPath => !graph.hasNode(defPath));
    return orphans.map(orphanPath => {
        return {
            message: 'Potential orphaned reusable object has been detected.',
            path: utils_1.safePointerToPath(orphanPath),
        };
    });
};
//# sourceMappingURL=unreferencedReusableObject.js.map