"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createHttpAndFileResolver = exports.httpAndFileResolver = void 0;
const json_ref_readers_1 = require("@stoplight/json-ref-readers");
const json_ref_resolver_1 = require("@stoplight/json-ref-resolver");
const request_1 = require("../request");
exports.httpAndFileResolver = createHttpAndFileResolver();
function createHttpAndFileResolver(opts) {
    const resolveHttp = json_ref_readers_1.createResolveHttp(Object.assign(Object.assign({}, request_1.DEFAULT_REQUEST_OPTIONS), opts));
    return new json_ref_resolver_1.Resolver({
        resolvers: {
            https: { resolve: resolveHttp },
            http: { resolve: resolveHttp },
            file: { resolve: json_ref_readers_1.resolveFile },
        },
    });
}
exports.createHttpAndFileResolver = createHttpAndFileResolver;
//# sourceMappingURL=http-and-file.js.map