import { Optional } from '@stoplight/types';
import { JSONPathExpression } from 'nimma';
import { IDocument } from './document';
import { IGivenNode, IProcessedRule, IThen } from './types';
import { DiagnosticSeverity } from '@stoplight/types';
export declare class Rule {
    readonly name: string;
    readonly description: string | null;
    readonly message: string | null;
    readonly severity: DiagnosticSeverity;
    readonly resolved: boolean;
    readonly formats: Optional<string[]>;
    readonly then: IThen[];
    readonly given: string[];
    readonly enabled: boolean;
    constructor(name: string, rule: IProcessedRule);
    matchesFormat(formats: IDocument['formats']): boolean;
}
export declare class OptimizedRule extends Rule {
    readonly expressions: JSONPathExpression[];
    constructor(name: string, rule: IProcessedRule);
    hookup(cb: (rule: OptimizedRule, node: IGivenNode) => void): void;
}
