"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.message = void 0;
const lodash_1 = require("lodash");
const replacer_1 = require("../utils/replacer");
const MessageReplacer = new replacer_1.Replacer(2);
MessageReplacer.addFunction('print', function (type) {
    if (typeof type !== 'string')
        return '';
    const { property, value } = this;
    switch (type) {
        case 'property':
            if (property !== void 0) {
                return `\`${property}\` property `;
            }
            return '';
        case 'value':
            if (lodash_1.isObject(value)) {
                return Array.isArray(value) ? 'Array[]' : 'Object{}';
            }
            return JSON.stringify(value);
        default:
            if (type in this && this[type] !== null) {
                return String(this[type]);
            }
            return '';
    }
});
exports.message = MessageReplacer.print.bind(MessageReplacer);
//# sourceMappingURL=message.js.map