"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAllOperations = void 0;
const isObject_1 = require("./isObject");
const validOperationKeys = ['get', 'head', 'post', 'put', 'patch', 'delete', 'options', 'trace'];
function* getAllOperations(paths) {
    if (!isObject_1.isObject(paths)) {
        return;
    }
    const item = {
        path: '',
        operation: '',
    };
    for (const path of Object.keys(paths)) {
        const operations = paths[path];
        if (!isObject_1.isObject(operations)) {
            continue;
        }
        item.path = path;
        for (const operation of Object.keys(operations)) {
            if (!isObject_1.isObject(operations[operation]) || !validOperationKeys.includes(operation)) {
                continue;
            }
            item.operation = operation;
            yield item;
        }
    }
}
exports.getAllOperations = getAllOperations;
//# sourceMappingURL=getAllOperations.js.map