"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RunnerRuntime = void 0;
const lifecycle_1 = require("@stoplight/lifecycle");
class RunnerRuntime extends lifecycle_1.EventEmitter {
    constructor() {
        super();
        this.revokables = [];
    }
    persist(obj) {
        const { proxy, revoke } = Proxy.revocable(obj, {});
        this.revokables.push(revoke);
        return proxy;
    }
    revoke() {
        let revokable;
        while ((revokable = this.revokables.shift())) {
            revokable();
        }
    }
    spawn() {
        return this.persist(Object.freeze({
            on: this.hijackDisposable(this.on),
        }));
    }
    hijackDisposable(fn) {
        return ((...args) => {
            this.revokables.push(fn.apply(this, args).dispose);
        });
    }
}
exports.RunnerRuntime = RunnerRuntime;
//# sourceMappingURL=runtime.js.map