"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isAKnownException = void 0;
const arePathsEqual_1 = require("./arePathsEqual");
exports.isAKnownException = (path, source, locations) => {
    for (const location of locations) {
        if (location.source !== null && source !== location.source) {
            continue;
        }
        if (location.path === null) {
            return true;
        }
        if (arePathsEqual_1.arePathsEqual(path, location.path)) {
            return true;
        }
    }
    return false;
};
//# sourceMappingURL=isAKnownException.js.map