import { DiagnosticSeverity } from '@stoplight/types';
import { RuleType } from './enums';
export interface IRule<T = string, O = unknown> {
    type?: RuleType;
    formats?: string[];
    documentationUrl?: string;
    message?: string;
    description?: string;
    severity?: DiagnosticSeverity | HumanReadableDiagnosticSeverity;
    recommended?: boolean;
    given: string | string[];
    resolved?: boolean;
    then: IThen<T, O> | Array<IThen<T, O>>;
}
export interface IProcessedRule extends IRule {
    enabled?: boolean;
}
export interface IThen<T = string, O = unknown> {
    field?: string;
    function: T;
    functionOptions?: O;
}
export declare type HumanReadableDiagnosticSeverity = 'error' | 'warn' | 'info' | 'hint' | 'off';
