"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Replacer = void 0;
const expression_eval_1 = require("expression-eval");
class Replacer {
    constructor(count) {
        this.regex = new RegExp(`#?${'{'.repeat(count)}([^}\n]+)${'}'.repeat(count)}`, 'g');
        this.functions = {};
    }
    addFunction(name, filter) {
        this.functions[name] = filter;
    }
    print(input, values) {
        return input.replace(this.regex, (substr, identifier, index) => {
            const shouldEvaluate = input[index] === '#';
            if (shouldEvaluate) {
                try {
                    return String(expression_eval_1.eval(expression_eval_1.parse(identifier), Object.assign(Object.assign({}, Object.entries(this.functions).reduce((fns, [name, fn]) => {
                        fns[name] = fn.bind(values);
                        return fns;
                    }, {})), values)));
                }
                catch (ex) {
                    console.warn(ex);
                    return '';
                }
            }
            if (!(identifier in values)) {
                return '';
            }
            return String(values[identifier]);
        });
    }
}
exports.Replacer = Replacer;
//# sourceMappingURL=replacer.js.map